diff -crN nakedmudv1.5/src/list.c nakedmudv2.0/src/list.c
*** nakedmudv1.5/src/list.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/list.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 21,41 ****
  #define TRUE    !(FALSE)
  #endif
  
! struct list_node {
    void *elem;              // the data we contain
    struct list_node *next;  // the next node in the list
    char removed;            // has the item been removed from the list? 
                             // char == bool
! };
  
  struct list_iterator {
    struct list      *L;     // the list we're iterating over
!   struct list_node *curr;  // the current element we're iterating on
  };
  
  struct list {
!   struct list_node *head;  // first element in the list
!   struct list_node *tail;  // last element in the list
    int size;                // how many elements are in the list?
    int iterators;           // how many iterators are going over us?
    int remove_pending;      // do we have to do a remove when the iterators die?
--- 21,41 ----
  #define TRUE    !(FALSE)
  #endif
  
! typedef struct list_node {
    void *elem;              // the data we contain
    struct list_node *next;  // the next node in the list
    char removed;            // has the item been removed from the list? 
                             // char == bool
! } LIST_NODE;
  
  struct list_iterator {
    struct list      *L;     // the list we're iterating over
!   LIST_NODE *curr;         // the current element we're iterating on
  };
  
  struct list {
!   LIST_NODE *head;         // first element in the list
!   LIST_NODE *tail;         // last element in the list
    int size;                // how many elements are in the list?
    int iterators;           // how many iterators are going over us?
    int remove_pending;      // do we have to do a remove when the iterators die?
***************
*** 45,51 ****
  //
  // Delete a list node, and all nodes attached to it
  //
! void deleteListNode(struct list_node *N) {
    if(N->next) deleteListNode(N->next);
    free(N);
  };
--- 45,51 ----
  //
  // Delete a list node, and all nodes attached to it
  //
! void deleteListNode(LIST_NODE *N) {
    if(N->next) deleteListNode(N->next);
    free(N);
  };
***************
*** 53,59 ****
  //
  // delete the list node, plus it's element using the supplied function
  //
! void deleteListNodeWith(struct list_node *N, void (*delete_func)(void *)) {
    if(N->next) deleteListNodeWith(N->next, delete_func);
    // we only want to delete elements that are actually in the list
    if(!N->removed)
--- 53,59 ----
  //
  // delete the list node, plus it's element using the supplied function
  //
! void deleteListNodeWith(LIST_NODE *N, void (*delete_func)(void *)) {
    if(N->next) deleteListNodeWith(N->next, delete_func);
    // we only want to delete elements that are actually in the list
    if(!N->removed)
***************
*** 64,71 ****
  //
  // Create a new list node containing the given element
  //
! struct list_node *newListNode(void *elem) {
!   struct list_node *N = malloc(sizeof(struct list_node));
    N->elem    = elem;
    N->next    = NULL;
    N->removed = FALSE;
--- 64,71 ----
  //
  // Create a new list node containing the given element
  //
! LIST_NODE *newListNode(void *elem) {
!   LIST_NODE *N = malloc(sizeof(LIST_NODE));
    N->elem    = elem;
    N->next    = NULL;
    N->removed = FALSE;
***************
*** 77,86 ****
  // take out all of the nodes that have been flagged as "removed"
  // from the list.
  //
! void listCleanRemoved(struct list *L) {
    // go through and kill all of the elements we removed if removes are pending
    if(L->remove_pending) {
!     struct list_node *node = L->head;
  
      // while our head is a removed element, 
      // pop it off and delete the list node
--- 77,86 ----
  // take out all of the nodes that have been flagged as "removed"
  // from the list.
  //
! void listCleanRemoved(LIST *L) {
    // go through and kill all of the elements we removed if removes are pending
    if(L->remove_pending) {
!     LIST_NODE *node = L->head;
  
      // while our head is a removed element, 
      // pop it off and delete the list node
***************
*** 96,102 ****
        while(node->next != NULL) {
  	// is our next element to be removed?
  	if(node->next->removed) {
! 	  struct list_node *removed = node->next;
  	  node->next = removed->next;
  	  removed->next = NULL;
  	  deleteListNode(removed);
--- 96,102 ----
        while(node->next != NULL) {
  	// is our next element to be removed?
  	if(node->next->removed) {
! 	  LIST_NODE *removed = node->next;
  	  node->next = removed->next;
  	  removed->next = NULL;
  	  deleteListNode(removed);
***************
*** 125,132 ****
  // List interface functions. Documentation in list.h
  //
  //*****************************************************************************
! struct list *newList() {
!   struct list *L    = malloc(sizeof(struct list));
    L->head           = NULL;
    L->tail           = NULL;
    L->size           = 0;
--- 125,132 ----
  // List interface functions. Documentation in list.h
  //
  //*****************************************************************************
! LIST *newList() {
!   LIST *L    = malloc(sizeof(LIST));
    L->head           = NULL;
    L->tail           = NULL;
    L->size           = 0;
***************
*** 136,156 ****
  };
  
  
! void deleteList(struct list *L) {
    if(L->head) deleteListNode(L->head);
    free(L);
  };
  
! void deleteListWith(struct list *L, void *func) {
    if(L->head) deleteListNodeWith(L->head, func);
    free(L);
  }
  
! void listPut(struct list *L, void *elem) {
    if(listIn(L, elem))
      return;
  
!   struct list_node *N = newListNode(elem);
    N->next = L->head;
    L->head = N;
    L->size++;
--- 136,156 ----
  };
  
  
! void deleteList(LIST *L) {
    if(L->head) deleteListNode(L->head);
    free(L);
  };
  
! void deleteListWith(LIST *L, void *func) {
    if(L->head) deleteListNodeWith(L->head, func);
    free(L);
  }
  
! void listPut(LIST *L, void *elem) {
    if(listIn(L, elem))
      return;
  
!   LIST_NODE *N = newListNode(elem);
    N->next = L->head;
    L->head = N;
    L->size++;
***************
*** 159,169 ****
  };
  
  
! void listQueue(struct list *L, void *elem) {
    if(listIn(L, elem))
      return;
  
!   struct list_node *N = newListNode(elem);
  
    if(L->head == NULL) {
      L->head = N;
--- 159,169 ----
  };
  
  
! void listQueue(LIST *L, void *elem) {
    if(listIn(L, elem))
      return;
  
!   LIST_NODE *N = newListNode(elem);
  
    if(L->head == NULL) {
      L->head = N;
***************
*** 177,194 ****
  }
  
  
! void *listPop(struct list *L) {
    return listRemoveNum(L, 0);
  };
  
  
! void listPush(struct list *L, void *elem) {
    listPut(L, elem);
  };
  
  
! int listIn(struct list *L, const void *elem) {
!   struct list_node *N = L->head;
  
    while(N != NULL) {
      if(!N->removed && N->elem == elem)
--- 177,194 ----
  }
  
  
! void *listPop(LIST *L) {
    return listRemoveNum(L, 0);
  };
  
  
! void listPush(LIST *L, void *elem) {
    listPut(L, elem);
  };
  
  
! int listIn(LIST *L, const void *elem) {
!   LIST_NODE *N = L->head;
  
    while(N != NULL) {
      if(!N->removed && N->elem == elem)
***************
*** 200,207 ****
  };
  
  
! int listRemove(struct list *L, const void *elem) {
!   struct list_node *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
--- 200,207 ----
  };
  
  
! int listRemove(LIST *L, const void *elem) {
!   LIST_NODE *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
***************
*** 241,247 ****
  	else {
  	  if(N->next == L->tail)
  	    L->tail = N;
! 	  struct list_node *tmp = N->next;
  	  N->next = tmp->next;
  	  tmp->next = NULL;
  	  deleteListNode(tmp);
--- 241,247 ----
  	else {
  	  if(N->next == L->tail)
  	    L->tail = N;
! 	  LIST_NODE *tmp = N->next;
  	  N->next = tmp->next;
  	  tmp->next = NULL;
  	  deleteListNode(tmp);
***************
*** 256,273 ****
    return FALSE;
  };
  
! void *listRemoveNum(struct list *L, int num) {
    void *elem = listGet(L, num);
    if(elem) listRemove(L, elem);
    return elem;
  }
  
! int listSize(struct list *L) {
    return L->size;
  }
  
! void *listGet(struct list *L, int num) {
!   struct list_node *node = L->head;
    int i;
  
    // move up to our first non-removed node
--- 256,273 ----
    return FALSE;
  };
  
! void *listRemoveNum(LIST *L, int num) {
    void *elem = listGet(L, num);
    if(elem) listRemove(L, elem);
    return elem;
  }
  
! int listSize(LIST *L) {
    return L->size;
  }
  
! void *listGet(LIST *L, int num) {
!   LIST_NODE *node = L->head;
    int i;
  
    // move up to our first non-removed node
***************
*** 283,303 ****
    return (node ? node->elem : NULL);
  }
  
! void *listHead(struct list *L) {
    return L->head;
  }
  
! void *listTail(struct list *L) {
    return L->tail;
  }
  
! int isListEmpty(struct list *L) {
    return (L->size == 0);
  }
  
! void *listGetWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   struct list_node *node = L->head;
  
    for(node = L->head; node != NULL; node = node->next) {
      if(node->removed)
--- 283,303 ----
    return (node ? node->elem : NULL);
  }
  
! void *listHead(LIST *L) {
    return L->head;
  }
  
! void *listTail(LIST *L) {
    return L->tail;
  }
  
! int isListEmpty(LIST *L) {
    return (L->size == 0);
  }
  
! void *listGetWith(LIST *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   LIST_NODE *node = L->head;
  
    for(node = L->head; node != NULL; node = node->next) {
      if(node->removed)
***************
*** 308,316 ****
    return NULL;
  }
  
! void *listRemoveWith(struct list *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   struct list_node *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
--- 308,316 ----
    return NULL;
  }
  
! void *listRemoveWith(LIST *L, const void *cmpto, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   LIST_NODE *N = L->head;
  
    // we don't have any contents
    if(N == NULL)
***************
*** 353,359 ****
  	  void *elem = N->next->elem;
  	  if(N->next == L->tail)
  	    L->tail = N;
! 	  struct list_node *tmp = N->next;
  	  N->next = tmp->next;
  	  tmp->next = NULL;
  	  deleteListNode(tmp);
--- 353,359 ----
  	  void *elem = N->next->elem;
  	  if(N->next == L->tail)
  	    L->tail = N;
! 	  LIST_NODE *tmp = N->next;
  	  N->next = tmp->next;
  	  tmp->next = NULL;
  	  deleteListNode(tmp);
***************
*** 369,377 ****
  }
  
  
! void listPutWith(struct list *L, void *elem, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   struct list_node *N = L->head;
  
    // we don't have any contents, or we're lower than the
    // first list content then just put it at the start
--- 369,377 ----
  }
  
  
! void listPutWith(LIST *L, void *elem, void *func) {
    int (* comparator)(const void *, const void *) = func;
!   LIST_NODE *N = L->head;
  
    // we don't have any contents, or we're lower than the
    // first list content then just put it at the start
***************
*** 386,392 ****
  	int val = comparator(elem, N->next->elem);
  	// we're less than or equal to it... sneak in
  	if(val <= 0) {
! 	  struct list_node *new_node = newListNode(elem);
  	  new_node->next = N->next;
  	  N->next = new_node;
  	  L->size++;
--- 386,392 ----
  	int val = comparator(elem, N->next->elem);
  	// we're less than or equal to it... sneak in
  	if(val <= 0) {
! 	  LIST_NODE *new_node = newListNode(elem);
  	  new_node->next = N->next;
  	  N->next = new_node;
  	  L->size++;
***************
*** 403,412 ****
  }
  
  
! void listSortWith(struct list *L, void *func) {
    // make a new list, and just pop our elements
    // into it while we still have 'em
!   struct list *new_list = newList();
  
    while(listSize(L) > 0)
      listPutWith(new_list, listPop(L), func);
--- 403,412 ----
  }
  
  
! void listSortWith(LIST *L, void *func) {
    // make a new list, and just pop our elements
    // into it while we still have 'em
!   LIST *new_list = newList();
  
    while(listSize(L) > 0)
      listPutWith(new_list, listPop(L), func);
***************
*** 423,433 ****
  }
  
  
! struct list *listCopyWith(struct list *L, void *func) {
    void *(* copy_func)(void *) = func;
!   struct list *newlist = newList();
  
!   struct list_node *N = NULL;
    for(N = L->head; N; N = N->next) {
      if(N->removed) continue;
      listQueue(newlist, copy_func(N->elem));
--- 423,433 ----
  }
  
  
! LIST *listCopyWith(LIST *L, void *func) {
    void *(* copy_func)(void *) = func;
!   LIST *newlist = newList();
  
!   LIST_NODE *N = NULL;
    for(N = L->head; N; N = N->next) {
      if(N->removed) continue;
      listQueue(newlist, copy_func(N->elem));
***************
*** 442,456 ****
  // The functions for the list iterator interface. Documentation is in list.h
  //
  //*****************************************************************************
! struct list_iterator *newListIterator(struct list *L) {
!   struct list_iterator *I = malloc(sizeof(struct list_iterator));
    I->L    = L;
    I->curr = I->L->head;
    L->iterators++;
    return I;
  };
  
! void deleteListIterator(struct list_iterator *I) {
    I->L->iterators--;
    // if we're at 0 iterators, clean the list of all removed elements
    if(I->L->iterators == 0)
--- 442,456 ----
  // The functions for the list iterator interface. Documentation is in list.h
  //
  //*****************************************************************************
! LIST_ITERATOR *newListIterator(LIST *L) {
!   LIST_ITERATOR *I = malloc(sizeof(LIST_ITERATOR));
    I->L    = L;
    I->curr = I->L->head;
    L->iterators++;
    return I;
  };
  
! void deleteListIterator(LIST_ITERATOR *I) {
    I->L->iterators--;
    // if we're at 0 iterators, clean the list of all removed elements
    if(I->L->iterators == 0)
***************
*** 458,464 ****
    free(I);
  };
  
! void *listIteratorNext(struct list_iterator *I) {
    if(I->curr)
      I->curr = I->curr->next;
  
--- 458,464 ----
    free(I);
  };
  
! void *listIteratorNext(LIST_ITERATOR *I) {
    if(I->curr)
      I->curr = I->curr->next;
  
***************
*** 471,477 ****
  
  // hmmm... we should really kill this function. 
  // Just let 'em create a new iterator
! void listIteratorReset(struct list_iterator *I) {
    // if we're the only iterator, take this opportunity to clean the list
    if(I->L->iterators == 1)
      listCleanRemoved(I->L);
--- 471,477 ----
  
  // hmmm... we should really kill this function. 
  // Just let 'em create a new iterator
! void listIteratorReset(LIST_ITERATOR *I) {
    // if we're the only iterator, take this opportunity to clean the list
    if(I->L->iterators == 1)
      listCleanRemoved(I->L);
***************
*** 479,485 ****
    I->curr = I->L->head;
  };
  
! void *listIteratorCurrent(struct list_iterator *I) {
    // hmmm... what if we're on a removed node?
    while(I->curr && I->curr->removed)
      I->curr = I->curr->next;
--- 479,485 ----
    I->curr = I->L->head;
  };
  
! void *listIteratorCurrent(LIST_ITERATOR *I) {
    // hmmm... what if we're on a removed node?
    while(I->curr && I->curr->removed)
      I->curr = I->curr->next;
diff -crN nakedmudv1.5/src/list.d nakedmudv2.0/src/list.d
*** nakedmudv1.5/src/list.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/list.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ list.d list.o: list.c list.h
diff -crN nakedmudv1.5/src/list.h nakedmudv2.0/src/list.h
*** nakedmudv1.5/src/list.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/list.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 13,22 ****
  //
  //*****************************************************************************
  
  //
  // Create a new list
  //
! struct list *newList();
  
  
  //
--- 13,25 ----
  //
  //*****************************************************************************
  
+ typedef struct list                       LIST;
+ typedef struct list_iterator              LIST_ITERATOR;
+ 
  //
  // Create a new list
  //
! LIST *newList();
  
  
  //
***************
*** 30,116 ****
  // that is passed in. The function should take one argument, and should be
  // compatible with the type of data in the list
  //
! void deleteListWith(struct list *L, void *func);
  
  
  //
  // Add an element to the list
  //
! void listPut(struct list *L, void *elem);
  
  
  //
  // Add an element to the end of the list
  //
! void listQueue(struct list *L, void *elem);
  
  
  //
  // Return true if the element is in the list. False otherwise
  //
! int listIn(struct list *L, const void *elem);
  
  
  //
  // Remove all instances of the elem from the list. Return
  // true if successful, and false otherwise.
  //
! int listRemove(struct list *L, const void *elem);
  
  
  //
  // Remove the element in the list at the specified place,
  // and return it
  //
! void *listRemoveNum(struct list *L, int num);
  
  
  //
  // remove the first element in the list, and return it
  //
! void *listPop(struct list *L);
  
  
  //
  // add the item to the head of the list
  //
! void listPush(struct list *L, void *elem);
  
  
  //
  // How many elements does the list have?
  //
! int listSize(struct list *L);
  
  //
  // Is the list empty?
  //
! int isListEmpty(struct list *L);
  
  
  //
  // get the element with the specific number
  //
! void *listGet(struct list *L, int num);
  
  
  //
  // Return the head of the list
  //
! void *listHead(struct list *L);
  
  
  //
  // Return the tail of the list
  //
! void *listTail(struct list *L);
  
  
  //
  // Put the element in the list in an ascending order, based on
  // what the comparator, func, tells us is the order.
  //
! void listPutWith(struct list *L, void *elem, void *func);
  
  
  //
--- 33,119 ----
  // that is passed in. The function should take one argument, and should be
  // compatible with the type of data in the list
  //
! void deleteListWith(LIST *L, void *func);
  
  
  //
  // Add an element to the list
  //
! void listPut(LIST *L, void *elem);
  
  
  //
  // Add an element to the end of the list
  //
! void listQueue(LIST *L, void *elem);
  
  
  //
  // Return true if the element is in the list. False otherwise
  //
! int listIn(LIST *L, const void *elem);
  
  
  //
  // Remove all instances of the elem from the list. Return
  // true if successful, and false otherwise.
  //
! int listRemove(LIST *L, const void *elem);
  
  
  //
  // Remove the element in the list at the specified place,
  // and return it
  //
! void *listRemoveNum(LIST *L, int num);
  
  
  //
  // remove the first element in the list, and return it
  //
! void *listPop(LIST *L);
  
  
  //
  // add the item to the head of the list
  //
! void listPush(LIST *L, void *elem);
  
  
  //
  // How many elements does the list have?
  //
! int listSize(LIST *L);
  
  //
  // Is the list empty?
  //
! int isListEmpty(LIST *L);
  
  
  //
  // get the element with the specific number
  //
! void *listGet(LIST *L, int num);
  
  
  //
  // Return the head of the list
  //
! void *listHead(LIST *L);
  
  
  //
  // Return the tail of the list
  //
! void *listTail(LIST *L);
  
  
  //
  // Put the element in the list in an ascending order, based on
  // what the comparator, func, tells us is the order.
  //
! void listPutWith(LIST *L, void *elem, void *func);
  
  
  //
***************
*** 119,125 ****
  // only take one argument. cmpto must be the thing we are compared against
  // in func.
  //
! void *listGetWith(struct list *L, const void *cmpto, void *func);
  
  
  //
--- 122,128 ----
  // only take one argument. cmpto must be the thing we are compared against
  // in func.
  //
! void *listGetWith(LIST *L, const void *cmpto, void *func);
  
  
  //
***************
*** 127,133 ****
  // TRUE if the item was found and removed. FALSE other wise. Cmpto must
  // be the thing we are compared against in func.
  //
! void *listRemoveWith(struct list *L, const void *cmpto, void *func);
  
  
  //
--- 130,136 ----
  // TRUE if the item was found and removed. FALSE other wise. Cmpto must
  // be the thing we are compared against in func.
  //
! void *listRemoveWith(LIST *L, const void *cmpto, void *func);
  
  
  //
***************
*** 135,179 ****
  // Func takes two arguments, and returns 0 if the two match. -1 is returned
  // if the first is less than the second, and 1 otherwise.
  //
! void listSortWith(struct list *L, void *func);
  
  
  //
  // Make a copy of the list. func is a function that takes one argument (the
  // data that is in the list) and returns a copy of that data.
  //
! struct list *listCopyWith(struct list *L, void *func);
  
  
  //
  // Create an iterator to go over the list
  //
! struct list_iterator *newListIterator(struct list *L);
  
  
  //
  // Delete the list iterator (but not the contents)
  //
! void deleteListIterator(struct list_iterator *I);
  
  
  //
  // Point the list iterator back at the head of the list
  //
! void listIteratorReset(struct list_iterator *I);
  
  
  //
  // Skip to the next element in the list. Return the next element
  // if one exists, and NULL otherwise.
  //
! void *listIteratorNext(struct list_iterator *I);
  
  
  //
  // return a pointer to the current list element
  //
! void *listIteratorCurrent(struct list_iterator *I);
  
  
  #endif // __LIST_H
--- 138,182 ----
  // Func takes two arguments, and returns 0 if the two match. -1 is returned
  // if the first is less than the second, and 1 otherwise.
  //
! void listSortWith(LIST *L, void *func);
  
  
  //
  // Make a copy of the list. func is a function that takes one argument (the
  // data that is in the list) and returns a copy of that data.
  //
! LIST *listCopyWith(LIST *L, void *func);
  
  
  //
  // Create an iterator to go over the list
  //
! LIST_ITERATOR *newListIterator(LIST *L);
  
  
  //
  // Delete the list iterator (but not the contents)
  //
! void deleteListIterator(LIST_ITERATOR *I);
  
  
  //
  // Point the list iterator back at the head of the list
  //
! void listIteratorReset(LIST_ITERATOR *I);
  
  
  //
  // Skip to the next element in the list. Return the next element
  // if one exists, and NULL otherwise.
  //
! void *listIteratorNext(LIST_ITERATOR *I);
  
  
  //
  // return a pointer to the current list element
  //
! void *listIteratorCurrent(LIST_ITERATOR *I);
  
  
  #endif // __LIST_H
diff -crN nakedmudv1.5/src/log.d nakedmudv2.0/src/log.d
*** nakedmudv1.5/src/log.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/log.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ log.d log.o: log.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h utils.h character.h storage.h log.h
